﻿Imports CustomerManagement.Core.Services
Imports Shareds.Interfaces

Namespace CustomerManagement.Infrastructure.ApplicationEvents
  Public Class CustomerUpdatedEvent
	  Implements IApplicationEvent
	Public Sub New(ByVal customer As CustomerDto, ByVal isNew As Boolean)
		Me.New()
	  Me.Customer = customer
	  Me.IsNew = isNew
	End Sub

	Public Sub New()
	  DateTimeEventOccurred = Date.Now
	End Sub

	Private privateCustomer As CustomerDto
	Public Property Customer() As CustomerDto
		Get
			Return privateCustomer
		End Get
		Private Set(ByVal value As CustomerDto)
			privateCustomer = value
		End Set
	End Property
	Private privateIsNew As Boolean
	Public Property IsNew() As Boolean
		Get
			Return privateIsNew
		End Get
		Private Set(ByVal value As Boolean)
			privateIsNew = value
		End Set
	End Property
	Private privateDateTimeEventOccurred As Date
        Public Property DateTimeEventOccurred() As Date Implements IApplicationEvent.DateTimeEventOccurred
            Get
                Return privateDateTimeEventOccurred
            End Get
            Private Set(ByVal value As Date)
                privateDateTimeEventOccurred = value
            End Set
        End Property

        Public ReadOnly Property EventType() As String Implements IApplicationEvent.EventType
            Get
                Return "CustomerUpdatedEvent"
            End Get
        End Property
  End Class
End Namespace