﻿Imports CustomerManagement.Infrastructure.Interfaces
Imports Newtonsoft.Json
Imports RabbitMQ.Client

Namespace CustomerManagement.Core.Services
  Public Class RabbitMqMessagePublisher
	  Implements IMessagePublisher

        Public Sub Publish(ByVal applicationEvent As Shareds.Interfaces.IApplicationEvent) Implements IMessagePublisher.Publish

            Dim factory = New ConnectionFactory()

            Dim conn As IConnection = factory.CreateConnection() 'uses defaults
            Using channel As IModel = conn.CreateModel()
                channel.ExchangeDeclare("CustomerUpdate", ExchangeType.Direct)
                channel.QueueDeclare("MyMSDNSampleQueue", False, False, False, Nothing)
                channel.QueueBind("MyMSDNSampleQueue", "CustomerUpdate", "", Nothing)
                Dim props As IBasicProperties = channel.CreateBasicProperties()
                Dim json As String = JsonConvert.SerializeObject(applicationEvent, Formatting.None)

                Dim messageBodyBytes() As Byte = System.Text.Encoding.UTF8.GetBytes(json)
                channel.BasicPublish("CustomerUpdate", "", props, messageBodyBytes)
            End Using
        End Sub

  End Class
End Namespace

