﻿Imports CustomerManagement.Infrastructure.ApplicationEvents
Imports CustomerManagement.Infrastructure.Interfaces
Imports Shareds.Interfaces

Namespace CustomerManagement.Core.Services
  Public Class CustomerUpdatedService
	  Implements IHandle(Of CustomerUpdatedEvent)
	Private ReadOnly _messagePublisher As IMessagePublisher


	Public Sub New(ByVal messagePublisher As IMessagePublisher)
	  _messagePublisher = messagePublisher 'rabbitmq here
	End Sub

        Public Sub Handle(ByVal customerUpdatedEvent As CustomerUpdatedEvent) Implements IHandle(Of CustomerUpdatedEvent).Handle
            _messagePublisher.Publish(customerUpdatedEvent)
        End Sub
  End Class
End Namespace