﻿Imports System.Collections
Imports CustomerManagement.Core.DomainEvents
Imports SalesDomain
Imports Shareds
Imports Shareds.Interfaces

Namespace CustomerManagement.Core.Model
	Public Class Customer
		Private Sub New(ByVal name As String, ByVal source As String)
			Id = Guid.NewGuid()
			Me.Name = name
			InitialDate = Date.UtcNow
			ModifiedDate = Date.UtcNow
			Me.Source = source
			BillingAddress = New Address()
			ShippingAddress = New Address()
	  _events = New List(Of IDomainEvent)()
		End Sub
		Public Shared Function Create(ByVal name As String, ByVal source As String) As Customer
			Return New Customer(name, source)
		End Function
		Private privateId As Guid
		Public Property Id() As Guid
			Get
				Return privateId
			End Get
			Private Set(ByVal value As Guid)
				privateId = value
			End Set
		End Property
		Private privateName As String
		Public Property Name() As String
			Get
				Return privateName
			End Get
			Private Set(ByVal value As String)
				privateName = value
			End Set
		End Property
		Private privateInitialDate As Date
		Public Property InitialDate() As Date
			Get
				Return privateInitialDate
			End Get
			Private Set(ByVal value As Date)
				privateInitialDate = value
			End Set
		End Property
		Private privateModifiedDate As Date
		Public Property ModifiedDate() As Date
			Get
				Return privateModifiedDate
			End Get
			Private Set(ByVal value As Date)
				privateModifiedDate = value
			End Set
		End Property
		Private privateSource As String
		Public Property Source() As String
			Get
				Return privateSource
			End Get
			Private Set(ByVal value As String)
				privateSource = value
			End Set
		End Property
		Public Property ShippingAddress() As Address

		Public Property BillingAddress() As Address
	Private ReadOnly _events As ICollection(Of IDomainEvent)
	Public ReadOnly Property Events() As ICollection(Of IDomainEvent)
	  Get
		  Return _events.ToList().AsReadOnly()
	  End Get

	End Property



		Public Sub CreateNewBillingAddress(ByVal street1 As String, ByVal street2 As String, ByVal city As String, ByVal region As String, ByVal country As String, ByVal postalCode As String)
			BillingAddress = New Address(street1, street2, city, region, country, postalCode)
		End Sub
		Public Sub CreateNewShippingAddress(ByVal street1 As String, ByVal street2 As String, ByVal city As String, ByVal region As String, ByVal country As String, ByVal postalCode As String)
			ShippingAddress = New Address(street1, street2, city, region, country, postalCode)
		End Sub
		Public Sub CopyBillingAddressToShippingAddress()
			ShippingAddress = New Address(BillingAddress.Street1, BillingAddress.Street2, BillingAddress.City, BillingAddress.Region, BillingAddress.Country, BillingAddress.PostalCode)
		End Sub



		Public Sub FixName(ByVal newName As String)
			Name = newName
			ModifiedDate = Date.UtcNow
			_events.Add(New CustomerNameFixedEvent())
		End Sub
	End Class
End Namespace