Imports CustomerManagement.Core.Services
Imports CustomerManagement.Infrastructure.Interfaces
Imports Shareds.Interfaces
Imports StructureMap
Imports StructureMap.Graph

Namespace CustomerManagementTests.DependencyResolution
  Public NotInheritable Class IoC
	Private Shared _container As IContainer

	Private Sub New()
	End Sub
	Public Shared ReadOnly Property Container() As IContainer
	  Get
		If _container Is Nothing Then
		  Initialize()
		End If
		Return _container
	  End Get
	End Property


	Public Shared Sub Initialize()
            _container = New Container(Sub(cfg)

                                           cfg.Scan(Sub(scan)
                                                        scan.TheCallingAssembly()
                                                        scan.WithDefaultConventions()
                                                        scan.AssemblyContainingType(Of IApplicationEvent)()
                                                        scan.ConnectImplementationsToTypesClosing(GetType(IHandle(Of )))
                                                    End Sub)
                                           cfg.For(Of IMessagePublisher)().Use(Of RabbitMqMessagePublisher)()
                                           cfg.For(Of CustomerUpdatedService)().Use(Of CustomerUpdatedService)()
                                       End Sub)
        End Sub

    End Class
End Namespace


