﻿'Altered from Pluralsight Domain-Driven Design Fundamentals Course (bit.ly/PS-DDD)

Imports System
Imports Shareds.Interfaces
Imports StructureMap
Imports StructureMapContainer

Namespace Shareds
    ''' <summary>
    '''   http://msdn.microsoft.com/en-gb/magazine/ee236415.aspx#id0400046
    ''' </summary>
    Public NotInheritable Class DomainEvents
        <ThreadStatic>
        Private Shared actions As List(Of System.Delegate)

        Private Sub New()
        End Sub
        Shared Sub New()
            Container = IocContainer.Container
        End Sub

        Public Shared Property Container() As IContainer

        Public Shared Sub Register(Of T As IDomainEvent)(ByVal callback As Action(Of T))
            If actions Is Nothing Then
                actions = New List(Of System.Delegate)()
            End If
            actions.Add(callback)
        End Sub

        Public Shared Sub ClearCallbacks()
            actions = Nothing
        End Sub

        Public Shared Sub Raise(Of T As IDomainEvent)(ByVal args As T)
            For Each handler In Container.GetAllInstances(Of IHandle(Of T))()
                handler.Handle(args)
            Next handler

            If actions IsNot Nothing Then
                For Each action As System.Delegate In actions
                    If TypeOf action Is Action(Of T) Then
                        CType(action, Action(Of T))(args)
                    End If
                Next action
            End If
        End Sub
    End Class
End Namespace