﻿Imports OrderManagement.DataMirroring.Models

Namespace OrderManagement.DataMirroring.DataPersistence
  Public Class SimpleRepo
	  Implements IDisposable


	Public Sub InsertCustomer(ByVal customer As Customer)
	  Using context = New CustomersContext()
		context.Customers.Add(customer)
		context.SaveChanges()
	  End Using
	End Sub

	Public Sub UpdateCustomer(ByVal customer As Customer)
	  Using context = New CustomersContext()
		context.Database.ExecuteSqlCommand("exec ReplaceCustomer {0}, {1}", customer.CustomerId, customer.ClientName)
	  End Using
	End Sub


	Private _disposed As Boolean

	Public Sub Dispose() Implements IDisposable.Dispose
		Dispose(True)
		GC.SuppressFinalize(Me)
	End Sub

   Protected Overrides Sub Finalize()
		Dispose(False)
   End Sub

	Protected Overridable Sub Dispose(ByVal disposing As Boolean)
		If _disposed Then
			Return
		End If

		If disposing Then
			' free other managed objects that implement
			' IDisposable only
		End If

		' release any unmanaged objects
		' set the object references to null

		_disposed = True
	End Sub
  End Class
End Namespace