' --------------------------------------------------------------------------------------------------------------------
' <copyright file="StructureMapDependencyResolver.cs" company="Web Advanced">
' Copyright 2012 Web Advanced (www.webadvanced.com)
' Licensed under the Apache License, Version 2.0 (the "License");
' you may not use this file except in compliance with the License.
' You may obtain a copy of the License at
'
' http://www.apache.org/licenses/LICENSE-2.0
' Unless required by applicable law or agreed to in writing, software
' distributed under the License is distributed on an "AS IS" BASIS,
' WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
' See the License for the specific language governing permissions and
' limitations under the License.
' </copyright>
' --------------------------------------------------------------------------------------------------------------------

Imports StructureMap

Namespace CustomerManagement.Infrastructure.DependencyResolution
	''' <summary>
	''' The structure map dependency resolver.
	''' </summary>
	Public Class StructureMapDependencyResolver
		Inherits StructureMapDependencyScope
		Implements IDependencyResolver
		#Region "Constructors and Destructors"

		''' <summary>
		''' Initializes a new instance of the <see cref="StructureMapDependencyResolver"/> class.
		''' </summary>
		''' <param name="container">
		''' The container.
		''' </param>
		Public Sub New(ByVal container As IContainer)
			MyBase.New(container)
		End Sub

		#End Region

		#Region "Public Methods and Operators"

		''' <summary>
		''' The begin scope.
		''' </summary>
		''' <returns>
		''' The System.Web.Http.Dependencies.IDependencyScope.
		''' </returns>
		Public Function BeginScope() As IDependencyScope
			Dim child As IContainer = Me.Container.GetNestedContainer()
			Return New StructureMapDependencyResolver(child)
		End Function

		#End Region
	End Class
End Namespace